<!DOCTYPE html>
<html lang="en">
<head>
  <title>Task 66 Province CRUD</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Province</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
			<label for="province-name">Tên Province</label>
		</div>
		<div class="col-sm-9">
			<input type="text" id="input-province-name" name="province-name" placeholder="Province name" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="province-code">Mã Province</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-province-code" name="province-code" placeholder="Province code" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="add_data" class="btn btn-success mr-3">Add Data</button>
		  <button id="update_data" class="btn btn-info mr-3">Update Data</button>
		  <button id="delete_data" class="btn btn-warning mr-3">Delete Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>Id</th>
        <th>Tên Province</th>
		<th>Mã Province</th>
      </tr>
  </table>
</div>
<script>
	$(document).ready(function(){
		var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"name"},
				{"data":"code"},
			]
		})

		var gBaseUrl = "http://localhost:8080/province";

		callAjaxApiGetAllProvinces();

		function callAjaxApiGetAllProvinces() {
			$.ajax({
				url: gBaseUrl + "/all",
				type: "GET",
				async: false,
				dataType: "json",
				success: function(res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function(err) {
					console.log(err.response);
				}
			})
		}
		
		// khi click vào 1 row trong danh sách, sẽ load dữ liệu vào form, bằng cách gọi API (GET)
		$("#user-table").on("click", "td", function() {
			onTableRowClick(this);
		});

		var gSelectedId = 0;

		function onTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = table.row(vClickedRow).data();
			gSelectedId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gSelectedId);
			callAjaxApiGetProvinceById(gSelectedId);
		}

		function callAjaxApiGetProvinceById(paramId) {
			$.ajax({
				url: gBaseUrl + "/detail/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadProvinceDataToForm(res);
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		function loadProvinceDataToForm(paramProvince) {
			$("#input-province-code").val(paramProvince.code);
			$("#input-province-name").val(paramProvince.name);
		}

		$("#update_data").on("click", function() {
			if(gSelectedId == 0) {
				alert("Chưa chọn Province nào");
			}
			else {
				var vProvinceData = readProvinceDataFromWeb();
				callAjaxApiUpdateProvinceById(gSelectedId, vProvinceData);
			}
		})

		function readProvinceDataFromWeb() {
			var vProvinceData = {
				code: $("#input-province-code").val(),
				name: $("#input-province-name").val()
			};			
			console.log("Thông tin Province đọc được là:");
			console.log(vProvinceData);
			return vProvinceData
		}

		function callAjaxApiUpdateProvinceById(paramId, paramProvinceData) {
			$.ajax({
				url: gBaseUrl + "/update/" + paramId,
				type: "PUT",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramProvinceData),
				success: function(res) {
					callAjaxApiGetAllProvinces();
					console.log("Update thành công cho Province có id " + paramId + ". Response là:");
					console.log(res);
					setTimeout(function(){
						alert("Update thành công cho Province có id " + paramId)}, 1000);
				},
				error: function(err){
					console.log(err.response);
					alert("Update không thành công. Xem console");
				}
			})
		}

		$("#add_data").on("click", function() {
			gSelectedId = 0;
			var vProvinceData = readProvinceDataFromWeb();
			callAjaxApiAddNewProvince(vProvinceData);
		})

		function callAjaxApiAddNewProvince(paramProvinceData) {
			$.ajax({
				url: gBaseUrl + "/create",
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramProvinceData),
				success: function(res) {
					callAjaxApiGetAllProvinces();
					gSelectedId = res.id;
					console.log("Tạo Province mới thành công. Response là:");
					console.log(res);
					setTimeout(function(){
						alert("Tạo Province mới thành công! Id mới là: " + res.id)}, 1000);
				},
				error: function(err){
					console.log(err.response);
					alert("Tạo Province mới không thành công! Xem console");
				}
			})
		}

		$("#delete_data").on("click", function() {
			if(gSelectedId == 0) {
				alert("Chưa chọn Province nào");
			}
			else {
				var vConfirmDelete = confirm("Xóa Province có id " + gSelectedId + "?");
				if(vConfirmDelete == true) {
					callAjaxApiDeleteProvinceById(gSelectedId);
				}
			}
		})

		function callAjaxApiDeleteProvinceById(paramProvinceId) {
			$.ajax({
				url: gBaseUrl + "/delete/" + paramProvinceId,
				type: "DELETE",
				dataType: "json",
				success: function(res) {
					gSelectedId = 0;
					callAjaxApiGetAllProvinces();
					console.log("Xóa Province có id " + paramProvinceId + " thành công. Response là:");
					console.log(res);
					setTimeout(function(){
						alert("Xóa Province có id " + paramProvinceId + " thành công!")}, 1000);
				},
				error: function(err){
					console.log(err.response);
					alert("Xóa Province có id " + paramProvinceId + " không thành công!");
				}
			})
		}
	})
</script>
</body>
</html>
